/// @cond EO_CXX_EO_IMPL

inline ::efl::eina::string_view elm::index_item::letter_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_letter_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::index_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline void elm::index_item::priority_set(int priority_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_priority_set(priority_));
}

inline ::efl::eina::string_view eo_cxx::elm::index_item::letter_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_index_item_letter_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::index_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline void eo_cxx::elm::index_item::priority_set(int priority_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_index_item_priority_set(priority_));
}

inline ::eo_cxx::elm::index_item::operator ::elm::index_item() const
{
   return *static_cast<::elm::index_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::index_item::operator ::elm::index_item&()
{
   return *static_cast<::elm::index_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::index_item::operator ::elm::index_item const&() const
{
   return *static_cast<::elm::index_item const*>(static_cast<void const*>(this));
}

template <typename T>
::efl::eina::string_view elm_index_item_letter_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->letter_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_index_item_selected_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool selected_)
{
   try
      {
         static_cast<T*>(self->this_)->selected_set(::efl::eolian::to_cxx<bool>(selected_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_index_item_priority_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int priority_)
{
   try
      {
         static_cast<T*>(self->this_)->priority_set(priority_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::index_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual ::efl::eina::string_view letter_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_index_item_letter_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void selected_set(bool selected_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_item_selected_set(::efl::eolian::to_c(selected_)));
      }

      virtual void priority_set(int priority_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_index_item_priority_set(priority_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::index_item >
{
   static constexpr int value = 
#if defined(INDEX_ITEM_PROTECTED) && defined(INDEX_ITEM_BETA)
      3
#elif defined(INDEX_ITEM_PROTECTED)
      3
#elif defined(INDEX_ITEM_BETA)
      3
#else
      3
#endif
      + operation_description_class_size<::elm::widget_item >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::index_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_letter_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_letter_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_selected_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_selected_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_index_item_priority_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_index_item_priority_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::index_item >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::index_item >::value + operation_description_class_size<::elm::widget_item>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::index_item>)
{
   return (ELM_INDEX_ITEM_CLASS);
}

} } }

/// @endcond

